#include <stdio.h>
#include <stdlib.h>

struct atomo {
       int dato;
  struct atomo *next;
         };
         
int testa_lista_vuota(struct atomo *testa)
{  
    if(testa==NULL)  /* lista vuota */
        return 1;
    else return 0;
}
int testa_lista(struct atomo *testa)
{
    /* da usare solo dopo avere verificato che la 
       lista non e' vuota */
       
       return testa->dato;
}

void in_testa(struct atomo **ptesta, int x)
{
     struct atomo *aux;
     
     aux=malloc(sizeof(struct atomo));
     if(aux)
       {  aux->dato=x;
          aux->next=*ptesta;
          *ptesta=aux;
       }
     else printf("Memoria non allocata\n");
}

void da_testa(struct atomo **ptesta)
{
     struct atomo *aux;
     
     if(*ptesta!=NULL) /* lista non vuota */
       {
         aux=*ptesta;
         *ptesta=(*ptesta)->next;
         free(aux);
       }
     else printf("Lista vuota\n");
}

void elimina (struct atomo **testa, int x)
{ struct atomo *l1,*l2;

  if(*testa==NULL)
   /* lista vuota*/
      {printf("lista vuota\n");
       return;
       }
  if(x==(*testa)->dato)
   /* elimino dalla testa*/
   {l1=*testa;
    *testa=l1->next;
    free(l1);
    return;
   }
  /* elimino dopo il primo elemento*/
   l1=(*testa)->next;
   l2=*testa;
   while(l1!=NULL)
     if(l1->dato==x)
       { l2->next=l1->next;
         free(l1);
         return;
       }
     else { l1=l1->next;
            l2=l2->next;
            }
    printf("Elemento non trovato\n");
}

void visualizza(struct atomo *testa)
{
     struct atomo *l;
     
     l=testa;
     while(l!=NULL)
     /* fino a quando non si arriva alla fine 
         della lista */
         {
               printf("%d\n",l->dato);
               l=l->next;
         }
}

void ricerca (struct atomo *testa, int x)
{
     struct atomo *l;
     int pos;
     
     pos=0;
     l=testa;
     while(l!=NULL)
     /* fino a quando non siamo arrivati alla 
        fine della lista*/
        if(l->dato==x)
          {  printf("trovato in %d\n",pos);
             return;
          }
        else {l=l->next;
              pos++;
              } 
        
     printf("Non trovato\n");   
}       

void ins_ordinato( struct atomo **testa,int x)
{
     struct atomo *l1,*l2,*aux;
     
     
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL)
        { printf("memoria non allocata\n");
          return;
        }
     
     aux->dato=x;
     if(*testa==NULL || x<= (*testa)->dato)
      /* inserimento in testa */
      {  aux->next=*testa;
         *testa=aux;
         return;
      }
      /* inserimento in posizione successiva
          alla prima */
      l1=(*testa)->next; /* l1 punta al secondo elemento*/
      l2=*testa;  /* l2 punta al primo elemento */
      while(l1!=NULL)
         if(x< l1->dato)
             break;
         else { /* si passa all'elemento successivo della lista */
              l1=l1->next;
              l2=l2->next;
              }
              
      l2->next=aux;
      aux->next=l1;
}
     
main() {
 struct atomo *tlista;
 int x,scelta;
 
 /* inizializzazione a NULL della lista*/ 
 tlista=NULL;
     
 do {
     printf("Scegli tra\n");
     printf("1) Inserimento in testa\n");
     printf("2) Cancellazione dalla testa\n");
     printf("3) visualizza lista\n");
     printf("4) ricerca in lista\n");
     printf("5) Inserimento ordinato\n");
     printf("6) Cancellazione di un elemento\n");
     printf("0) Fine\n\n");
     scanf("%d",&scelta);
     switch(scelta) {
        case 1:  printf("Ins. numero ");
                 scanf("%d",&x);
                 in_testa(&tlista,x);
                 break;
        case 2:  da_testa(&tlista);
                 break;
        case 3:  visualizza(tlista);
                 break;
        case 4:  printf("Ins. valore da cercare ");
                 scanf("%d",&x);
                 ricerca(tlista,x);
                 break;
        case 5:  printf("Ins. numero ");
                 scanf("%d",&x);
                 ins_ordinato(&tlista,x);
                 break;
        case 6:  printf("Ins. numero da eliminaare ");
                 scanf("%d",&x);
                 elimina(&tlista,x);
                 break;
        default:;
        }
        } while(scelta!=0);
        
        /* liberiamo la memoria occupata dalla lista*/
        while(tlista!=NULL)
           /* fino a quando la lista non diventa vuota*/
            da_testa(&tlista);
            
}        
               
     
