#include <stdio.h>

struct atomo {
       int dato;
       struct atomo *next;
       };
struct coda {
       struct atomo *primo,*ultimo;
       };
       
int  test_coda_vuota(struct coda Q)
{
     if(Q.primo==NULL)
       return 1; /* coda vuota*/
     else return 0; /* coda non vuota*/
}

int primo(struct coda Q)
{ /* da usare solo se la coda non e' vuota*/
  return Q.primo->dato;
}

void in_coda(struct coda *Q, int x)
{
     struct atomo *aux;
     
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL)
        return;
     aux->dato=x;
     aux->next=NULL;
     if(Q->primo==NULL) /* se la coda e' vuota*/
          Q->primo=aux;
     else Q->ultimo->next=aux;
     Q->ultimo=aux;
}

void out_coda(struct coda *Q)
{
     struct atomo *aux;
     
     if(Q->primo==NULL) /* coda vuota*/
       return;
     
     aux=Q->primo;
     Q->primo=aux->next;
     free(aux);
     if(Q->primo==NULL) /* se la codae' diventata vuota*/
           Q->ultimo=NULL;
}

void visualizza(struct coda Q)
{
     struct atomo *l;
     
     l=Q.primo;
     while(l!=NULL)
       {printf("%d\n",l->dato);
        l=l->next;
        }
}

main() {
 struct coda Q;
 int x,scelta;
 
 /* inizializzazione della coda*/
 Q.primo=NULL;
 Q.ultimo=NULL;
 
 do {
     printf("scegli tra\n");
     printf("1) primo coda\n");
     printf("2) in coda\n3)out coda\n");
     printf("4) visualizza coda\n0) fine\n\n");
     scanf("%d",&scelta);
     switch(scelta) {
      case 1 :  if(test_coda_vuota(Q)==0)
                 /* se la coda non e' vuota*/
                 printf("%d\n",primo(Q));
                break;
      case 2 :  printf("Valore da inserire ");
                scanf("%d",&x);
                in_coda(&Q,x);
                break;
      case 3:   out_coda(&Q);
                break;
      case 4:   visualizza(Q);
                break;
      default:; }
      } while(scelta!=NULL);
      
      /* liberiamo la memoria occupata dalla coda*/
      while(Q.primo!=NULL)
        out_coda(&Q);
}
        
 


